Author: rti Category: OS: Mac
Created: 06/14/2011 Assignee: kervala
Updated: 03/31/2012 Due date:
Subject: Adopt WITH_STATIC_EXTERNAL for Mac OS X
Description

see r1626

History
#1 - 06/15/2011 04:11 pm - rti

The default value of CMAKE_FIND_LIBRARY_SUFFIXES on Mac OS X is ".dylib;.so;.a". So it prefers .dylib over .so over .a.

For some libraries, the system might not provide static ones (e.g. Apple provided libz, libSystem, etc.). 
Having a list of extensions enables a fall back solution, while just setting it to one of the extensions will simply fail if the desired one is not available.
WITH_STATIC_EXTERNAL could set CMAKE_FIND_LIBRARY_SUFFIXES to something like .a;.dylib;.so on Mac OS X.

Maybe a similar way could be interesting for Linux based systems as well?

#2 - 03/07/2012 08:46 pm - kervala
- Status changed from New to Assigned
- Assignee set to kervala

#3 - 03/07/2012 08:50 pm - kervala

As suggested by rti, I updated code to check for :

    -  Mac OS X : .dylib .so .a if WITH_STATIC_EXTERNAL is OFF
    -  Mac OS X : .a .dylib .so if WITH_STATIC_EXTERNAL is ON
    -  Linux : .so .a if WITH_STATIC_EXTERNAL is OFF
    -  Linux : .a .so if WITH_STATIC_EXTERNAL is ON

#4 - 03/07/2012 08:50 pm - kervala
- Status changed from Assigned to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:02bc0b6f7765.

#5 - 03/07/2012 08:50 pm - kervala
- Target version set to Version 0.9.0

#6 - 03/07/2012 08:54 pm - kervala

The problem we had recently while compiling a full static client is that libGL.a doesn't exist because it's provided by graphics card drivers, it could exist
other cases as for OpenAL which doesn't provide a static library under Ubuntu last version.

#7 - 03/31/2012 06:25 pm - kervala
- Status changed from Resolved to Closed
